import java.lang.Math;

public class Datamanipulation {
	//!/bin/env python
	// A library with misc. data manipulation functions
	//  (c) 2005 - Intrepid Software
	//   Bas Westerbaan <bas.westerbaan@gmail.com>

	String hexChars = "0123456789abcdef";

	// xors two numbers with a specific width
	public long Xor(long x, long y, int w){
		long r, pp, ppm;
		
		r = 0;
	    for (int p=0; p<=w; p++){
	        pp = (long)Math.pow(256, p);
	        ppm = pp * 256 - 1;
	        r += ((((int)ppm & x) >> (p * 8)) ^ (((int)ppm & y) >> (p * 8))) << p * 8;	    	
	    }
	    return r;
	}

/*	public void TestXor(int x, int y,int w){
	System.out.println(PadStringLeft(NumberToBinary(x),w*8,'0'));
	System.out.println(PadStringLeft(NumberToBinary(y),w*8,'0'));
	System.out.println(PadStringLeft(NumberToBinary(Xor(x,y,w)),w*8,'0'));
	}*/

	// returns a binary string representation of a number.
	public String NumberToBinary(long n){
	    int p = 0;   // current position
	    long pp = 1;  // position to the second power, default: pow(2, 0)
	    String r = "";  // return
	    while (n >= pp){
	        if ((n & pp) > 0)
	            r += "1";
	        else
	            r += "0";
	        p += 1;
	        pp = (long)Math.pow(2, p); // cache power
	    }
	    return ReverseString(r);
	}

	// returns a hexadecimal representation of a number. 
	public String NumberToHexadecimal(long n){
	    int p   = 0;  // current position
	    long ppm = 15; // next position to the sixteenth power minus 1, default: pow(16, 1)
	             //  used as Mask
	    long pp  = 1;  // cirremtposition to the sixteenth power, default: pow(16, 0)
	    String r  = "";  // return
	    while (n >= pp){
	        int v = (int)((n & (long)ppm) >> (p * 4));
	        r += hexChars.charAt(v);
	        p += 1;
	        pp = (long)Math.pow(16, p);
	        ppm = pp * 16  - 1;  // Math.pow(16, p + 1) - 1
	    }
	    return ReverseString(r);
	}

	// return the number represented by a hexadecimal string
	public long NumberFromHexadecimal(String s){
	    long r = 0;
	    int p = 0;
	    for (int i=s.length()-1; i>-1; i--){
	        r += hexChars.indexOf(s.toLowerCase().charAt(i)) * Math.pow(16, p);
	        p += 1;
	    }
	    return r;
	}

	// returns the number represented by a binary string
	public long NumberFromBinary(String s){
	    long r = 0;
	    int p = 0;
	    for (int i=s.length()-1; i>-1; i--){
	        if (s.charAt(i)=='1')
	            r += Math.pow(2, p);
	        p += 1;
	    }
	    return r;
	}
	    
	// reverses a string (not very efficiently, maybe should use generator)
	public String ReverseString(String s){
	    String r = "";
	    for (int i=s.length()-1; i>-1; i--)
	        r += s.charAt(i);
	    return r;
	}

	// pads a string 's' on the left with 'c' until it has the length 'l'
	public String PadStringLeft(String s, int l, char c){
	    String r = s;
	    while (r.length() < l)
	        r = c + r;
	    return r;
	}

	// idem, but now on the right
	public String PadStringRight(String s, int l, char c){
	    String r = s;
	    while (r.length() < l)
	        r += c;
	    return r;
	}
}
